Avoid ci-management archiving files twice
[csit.git] / resources / libraries / bash / function / common.sh
1 # Copyright (c) 2019 Cisco and/or its affiliates.
2 # Copyright (c) 2019 PANTHEON.tech and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -exuo pipefail
16
17 # This library defines functions used by multiple entry scripts.
18 # Keep functions ordered alphabetically, please.
19
20 # TODO: Add a link to bash style guide.
21 # TODO: Consider putting every die into a {} block,
22 #   the code might become more readable (but longer).
23
24
25 function activate_docker_topology () {
26
27     # Create virtual vpp-device topology. Output of the function is topology
28     # file describing created environment saved to a file.
29     #
30     # Variables read:
31     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
32     # - TOPOLOGIES - Available topologies.
33     # - NODENESS - Node multiplicity of desired testbed.
34     # - FLAVOR - Node flavor string, usually describing the processor.
35     # - IMAGE_VER_FILE - Name of file that contains the image version.
36     # - CSIT_DIR - Directory where ${IMAGE_VER_FILE} is located.
37     # Variables set:
38     # - WORKING_TOPOLOGY - Path to topology file.
39
40     set -exuo pipefail
41
42     source "${BASH_FUNCTION_DIR}/device.sh" || {
43         die "Source failed!"
44     }
45
46     device_image="$(< ${CSIT_DIR}/${IMAGE_VER_FILE})"
47     case_text="${NODENESS}_${FLAVOR}"
48     case "${case_text}" in
49         "1n_skx" | "1n_tx2")
50             # We execute reservation over csit-shim-dcr (ssh) which runs sourced
51             # script's functions. Env variables are read from ssh output
52             # back to localhost for further processing.
53             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
54             ssh="ssh root@${hostname} -p 6022"
55             run="activate_wrapper ${NODENESS} ${FLAVOR} ${device_image}"
56             # backtics to avoid https://midnight-commander.org/ticket/2142
57             env_vars=`${ssh} "$(declare -f); ${run}"` || {
58                 die "Topology reservation via shim-dcr failed!"
59             }
60             set -a
61             source <(echo "$env_vars" | grep -v /usr/bin/docker) || {
62                 die "Source failed!"
63             }
64             set +a
65             ;;
66         "1n_vbox")
67             # We execute reservation on localhost. Sourced script automatially
68             # sets environment variables for further processing.
69             activate_wrapper "${NODENESS}" "${FLAVOR}" "${device_image}" || die
70             ;;
71         *)
72             die "Unknown specification: ${case_text}!"
73     esac
74
75     trap 'deactivate_docker_topology' EXIT || {
76          die "Trap attempt failed, please cleanup manually. Aborting!"
77     }
78
79     # Replace all variables in template with those in environment.
80     source <(echo 'cat <<EOF >topo.yml'; cat ${TOPOLOGIES[0]}; echo EOF;) || {
81         die "Topology file create failed!"
82     }
83
84     WORKING_TOPOLOGY="/tmp/topology.yaml"
85     mv topo.yml "${WORKING_TOPOLOGY}" || {
86         die "Topology move failed!"
87     }
88     cat ${WORKING_TOPOLOGY} | grep -v password || {
89         die "Topology read failed!"
90     }
91 }
92
93
94 function activate_virtualenv () {
95
96     # Update virtualenv pip package, delete and create virtualenv directory,
97     # activate the virtualenv, install requirements, set PYTHONPATH.
98
99     # Arguments:
100     # - ${1} - Path to existing directory for creating virtualenv in.
101     #          If missing or empty, ${CSIT_DIR} is used.
102     # - ${2} - Path to requirements file, ${CSIT_DIR}/requirements.txt if empty.
103     # Variables read:
104     # - CSIT_DIR - Path to existing root of local CSIT git repository.
105     # Variables exported:
106     # - PYTHONPATH - CSIT_DIR, as CSIT Python scripts usually need this.
107     # Functions called:
108     # - die - Print to stderr and exit.
109
110     set -exuo pipefail
111
112     root_path="${1-$CSIT_DIR}"
113     env_dir="${root_path}/env"
114     req_path=${2-$CSIT_DIR/requirements.txt}
115     rm -rf "${env_dir}" || die "Failed to clean previous virtualenv."
116     pip install --upgrade virtualenv || {
117         die "Virtualenv package install failed."
118     }
119     virtualenv "${env_dir}" || {
120         die "Virtualenv creation failed."
121     }
122     set +u
123     source "${env_dir}/bin/activate" || die "Virtualenv activation failed."
124     set -u
125     pip install --upgrade -r "${req_path}" || {
126         die "Requirements installation failed."
127     }
128     # Most CSIT Python scripts assume PYTHONPATH is set and exported.
129     export PYTHONPATH="${CSIT_DIR}" || die "Export failed."
130 }
131
132
133 function archive_tests () {
134
135     # Create .tar.xz of generated/tests for archiving.
136     # To be run after generate_tests, kept separate to offer more flexibility.
137
138     # Directory read:
139     # - ${GENERATED_DIR}/tests - Tree of executed suites to archive.
140     # File rewriten:
141     # - ${ARCHIVE_DIR}/tests.tar.xz - Archive of generated tests.
142
143     set -exuo pipefail
144
145     tar c "${GENERATED_DIR}/tests" | xz -9e > "${ARCHIVE_DIR}/tests.tar.xz" || {
146         die "Error creating archive of generated tests."
147     }
148 }
149
150
151 function check_download_dir () {
152
153     # Fail if there are no files visible in ${DOWNLOAD_DIR}.
154     #
155     # Variables read:
156     # - DOWNLOAD_DIR - Path to directory pybot takes the build to test from.
157     # Directories read:
158     # - ${DOWNLOAD_DIR} - Has to be non-empty to proceed.
159     # Functions called:
160     # - die - Print to stderr and exit.
161
162     set -exuo pipefail
163
164     if [[ ! "$(ls -A "${DOWNLOAD_DIR}")" ]]; then
165         die "No artifacts downloaded!"
166     fi
167 }
168
169
170 function cleanup_topo () {
171
172     # Variables read:
173     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
174     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
175
176     set -exuo pipefail
177
178     python "${PYTHON_SCRIPTS_DIR}/topo_cleanup.py" -t "${WORKING_TOPOLOGY}"
179     # Not using "|| die" as some callers might want to ignore errors,
180     # e.g. in teardowns, such as unreserve.
181 }
182
183
184 function common_dirs () {
185
186     # Set global variables, create some directories (without touching content).
187
188     # Variables set:
189     # - BASH_FUNCTION_DIR - Path to existing directory this file is located in.
190     # - CSIT_DIR - Path to existing root of local CSIT git repository.
191     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
192     # - RESOURCES_DIR - Path to existing CSIT subdirectory "resources".
193     # - TOOLS_DIR - Path to existing resources subdirectory "tools".
194     # - PYTHON_SCRIPTS_DIR - Path to existing tools subdirectory "scripts".
195     # - ARCHIVE_DIR - Path to created CSIT subdirectory "archive".
196     # - DOWNLOAD_DIR - Path to created CSIT subdirectory "download_dir".
197     # - GENERATED_DIR - Path to created CSIT subdirectory "generated".
198     # Directories created if not present:
199     # ARCHIVE_DIR, DOWNLOAD_DIR, GENERATED_DIR.
200     # Functions called:
201     # - die - Print to stderr and exit.
202
203     set -exuo pipefail
204
205     BASH_FUNCTION_DIR="$(dirname "$(readlink -e "${BASH_SOURCE[0]}")")" || {
206         die "Some error during localizing this source directory."
207     }
208     # Current working directory could be in a different repo, e.g. VPP.
209     pushd "${BASH_FUNCTION_DIR}" || die "Pushd failed"
210     CSIT_DIR="$(readlink -e "$(git rev-parse --show-toplevel)")" || {
211         die "Readlink or git rev-parse failed."
212     }
213     popd || die "Popd failed."
214     TOPOLOGIES_DIR="$(readlink -e "${CSIT_DIR}/topologies/available")" || {
215         die "Readlink failed."
216     }
217     RESOURCES_DIR="$(readlink -e "${CSIT_DIR}/resources")" || {
218         die "Readlink failed."
219     }
220     TOOLS_DIR="$(readlink -e "${RESOURCES_DIR}/tools")" || {
221         die "Readlink failed."
222     }
223     PYTHON_SCRIPTS_DIR="$(readlink -e "${TOOLS_DIR}/scripts")" || {
224         die "Readlink failed."
225     }
226
227     ARCHIVE_DIR="$(readlink -f "${CSIT_DIR}/archive")" || {
228         die "Readlink failed."
229     }
230     mkdir -p "${ARCHIVE_DIR}" || die "Mkdir failed."
231     DOWNLOAD_DIR="$(readlink -f "${CSIT_DIR}/download_dir")" || {
232         die "Readlink failed."
233     }
234     mkdir -p "${DOWNLOAD_DIR}" || die "Mkdir failed."
235     GENERATED_DIR="$(readlink -f "${CSIT_DIR}/generated")" || {
236         die "Readlink failed."
237     }
238     mkdir -p "${GENERATED_DIR}" || die "Mkdir failed."
239 }
240
241
242 function compose_pybot_arguments () {
243
244     # Variables read:
245     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
246     # - DUT - CSIT test/ subdirectory, set while processing tags.
247     # - TAGS - Array variable holding selected tag boolean expressions.
248     # - TOPOLOGIES_TAGS - Tag boolean expression filtering tests for topology.
249     # - TEST_CODE - The test selection string from environment or argument.
250     # Variables set:
251     # - PYBOT_ARGS - String holding part of all arguments for pybot.
252     # - EXPANDED_TAGS - Array of strings pybot arguments compiled from tags.
253
254     set -exuo pipefail
255
256     # No explicit check needed with "set -u".
257     PYBOT_ARGS=("--loglevel" "TRACE")
258     PYBOT_ARGS+=("--variable" "TOPOLOGY_PATH:${WORKING_TOPOLOGY}")
259
260     case "${TEST_CODE}" in
261         *"device"*)
262             PYBOT_ARGS+=("--suite" "tests.${DUT}.device")
263             ;;
264         *"func"*)
265             PYBOT_ARGS+=("--suite" "tests.${DUT}.func")
266             ;;
267         *"perf"*)
268             PYBOT_ARGS+=("--suite" "tests.${DUT}.perf")
269             ;;
270         *)
271             die "Unknown specification: ${TEST_CODE}"
272     esac
273
274     EXPANDED_TAGS=()
275     for tag in "${TAGS[@]}"; do
276         if [[ ${tag} == "!"* ]]; then
277             EXPANDED_TAGS+=("--exclude" "${tag#$"!"}")
278         else
279             EXPANDED_TAGS+=("--include" "${TOPOLOGIES_TAGS}AND${tag}")
280         fi
281     done
282 }
283
284
285 function deactivate_docker_topology () {
286
287     # Deactivate virtual vpp-device topology by removing containers.
288     #
289     # Variables read:
290     # - NODENESS - Node multiplicity of desired testbed.
291     # - FLAVOR - Node flavor string, usually describing the processor.
292
293     set -exuo pipefail
294
295     case_text="${NODENESS}_${FLAVOR}"
296     case "${case_text}" in
297         "1n_skx" | "1n_tx2")
298             hostname=$(grep search /etc/resolv.conf | cut -d' ' -f3) || die
299             ssh="ssh root@${hostname} -p 6022"
300             env_vars=$(env | grep CSIT_ | tr '\n' ' ' ) || die
301             ${ssh} "$(declare -f); deactivate_wrapper ${env_vars}" || {
302                 die "Topology cleanup via shim-dcr failed!"
303             }
304             ;;
305         "1n_vbox")
306             enter_mutex || die
307             clean_environment || {
308                 die "Topology cleanup locally failed!"
309             }
310             exit_mutex || die
311             ;;
312         *)
313             die "Unknown specification: ${case_text}!"
314     esac
315 }
316
317
318 function die () {
319
320     # Print the message to standard error end exit with error code specified
321     # by the second argument.
322     #
323     # Hardcoded values:
324     # - The default error message.
325     # Arguments:
326     # - ${1} - The whole error message, be sure to quote. Optional
327     # - ${2} - the code to exit with, default: 1.
328
329     set -x
330     set +eu
331     warn "${1:-Unspecified run-time error occurred!}"
332     exit "${2:-1}"
333 }
334
335
336 function die_on_pybot_error () {
337
338     # Source this fragment if you want to abort on any failed test case.
339     #
340     # Variables read:
341     # - PYBOT_EXIT_STATUS - Set by a pybot running fragment.
342     # Functions called:
343     # - die - Print to stderr and exit.
344
345     set -exuo pipefail
346
347     if [[ "${PYBOT_EXIT_STATUS}" != "0" ]]; then
348         die "Test failures are present!" "${PYBOT_EXIT_STATUS}"
349     fi
350 }
351
352
353 function generate_tests () {
354
355     # Populate ${GENERATED_DIR}/tests based on ${CSIT_DIR}/tests/.
356     # Any previously existing content of ${GENERATED_DIR}/tests is wiped before.
357     # The generation is done by executing any *.py executable
358     # within any subdirectory after copying.
359
360     # This is a separate function, because this code is called
361     # both by autogen checker and entries calling run_pybot.
362
363     # Directories read:
364     # - ${CSIT_DIR}/tests - Used as templates for the generated tests.
365     # Directories replaced:
366     # - ${GENERATED_DIR}/tests - Overwritten by the generated tests.
367
368     set -exuo pipefail
369
370     rm -rf "${GENERATED_DIR}/tests" || die
371     cp -r "${CSIT_DIR}/tests" "${GENERATED_DIR}/tests" || die
372     cmd_line=("find" "${GENERATED_DIR}/tests" "-type" "f")
373     cmd_line+=("-executable" "-name" "*.py")
374     file_list=$("${cmd_line[@]}") || die
375
376     for gen in ${file_list}; do
377         directory="$(dirname "${gen}")" || die
378         filename="$(basename "${gen}")" || die
379         pushd "${directory}" || die
380         ./"${filename}" || die
381         popd || die
382     done
383 }
384
385
386 function get_test_code () {
387
388     # Arguments:
389     # - ${1} - Optional, argument of entry script (or empty as unset).
390     #   Test code value to override job name from environment.
391     # Variables read:
392     # - JOB_NAME - String affecting test selection, default if not argument.
393     # Variables set:
394     # - TEST_CODE - The test selection string from environment or argument.
395     # - NODENESS - Node multiplicity of desired testbed.
396     # - FLAVOR - Node flavor string, usually describing the processor.
397
398     set -exuo pipefail
399
400     TEST_CODE="${1-}" || die "Reading optional argument failed, somehow."
401     if [[ -z "${TEST_CODE}" ]]; then
402         TEST_CODE="${JOB_NAME-}" || die "Reading job name failed, somehow."
403     fi
404
405     case "${TEST_CODE}" in
406         *"1n-vbox"*)
407             NODENESS="1n"
408             FLAVOR="vbox"
409             ;;
410         *"1n-skx"*)
411             NODENESS="1n"
412             FLAVOR="skx"
413             ;;
414        *"1n-tx2"*)
415             NODENESS="1n"
416             FLAVOR="tx2"
417             ;;
418         *"2n-skx"*)
419             NODENESS="2n"
420             FLAVOR="skx"
421             ;;
422         *"3n-skx"*)
423             NODENESS="3n"
424             FLAVOR="skx"
425             ;;
426         *"2n-dnv"*)
427             NODENESS="2n"
428             FLAVOR="dnv"
429             ;;
430         *"3n-dnv"*)
431             NODENESS="3n"
432             FLAVOR="dnv"
433             ;;
434         *"3n-tsh"*)
435             NODENESS="3n"
436             FLAVOR="tsh"
437             ;;
438         *)
439             # Fallback to 3-node Haswell by default (backward compatibility)
440             NODENESS="3n"
441             FLAVOR="hsw"
442             ;;
443     esac
444 }
445
446
447 function get_test_tag_string () {
448
449     # Variables read:
450     # - GERRIT_EVENT_TYPE - Event type set by gerrit, can be unset.
451     # - GERRIT_EVENT_COMMENT_TEXT - Comment text, read for "comment-added" type.
452     # - TEST_CODE - The test selection string from environment or argument.
453     # Variables set:
454     # - TEST_TAG_STRING - The string following trigger word in gerrit comment.
455     #   May be empty, not set on event types not adding comment.
456
457     # TODO: ci-management scripts no longer need to perform this.
458
459     set -exuo pipefail
460
461     trigger=""
462     if [[ "${GERRIT_EVENT_TYPE-}" == "comment-added" ]]; then
463         case "${TEST_CODE}" in
464             *"device"*)
465                 # On parsing error, ${trigger} stays empty.
466                 trigger="$(echo "${GERRIT_EVENT_COMMENT_TEXT}" \
467                     | grep -oE '(devicetest$|devicetest[[:space:]].+$)')" \
468                     || true
469                 # Set test tags as string.
470                 TEST_TAG_STRING="${trigger#$"devicetest"}"
471                 ;;
472             *"perf"*)
473                 # On parsing error, ${trigger} stays empty.
474                 comment="${GERRIT_EVENT_COMMENT_TEXT}"
475                 # As "perftest" can be followed by something, we substitute it.
476                 comment="${comment/perftest-2n/perftest}"
477                 comment="${comment/perftest-3n/perftest}"
478                 comment="${comment/perftest-hsw/perftest}"
479                 comment="${comment/perftest-skx/perftest}"
480                 comment="${comment/perftest-dnv/perftest}"
481                 comment="${comment/perftest-tsh/perftest}"
482                 tag_string="$(echo "${comment}" \
483                     | grep -oE '(perftest$|perftest[[:space:]].+$)' || true)"
484                 # Set test tags as string.
485                 TEST_TAG_STRING="${tag_string#$"perftest"}"
486                 ;;
487             *)
488                 die "Unknown specification: ${TEST_CODE}"
489         esac
490     fi
491 }
492
493
494 function reserve_and_cleanup_testbed () {
495
496     # Reserve physical testbed, perform cleanup, register trap to unreserve.
497     # When cleanup fails, remove from topologies and keep retrying
498     # until all topologies are removed.
499     #
500     # Variables read:
501     # - TOPOLOGIES - Array of paths to topology yaml to attempt reservation on.
502     # - PYTHON_SCRIPTS_DIR - Path to directory holding the reservation script.
503     # - BUILD_TAG - Any string suitable as filename, identifying
504     #   test run executing this function. May be unset.
505     # - BUILD_URL - Any string suitable as URL, identifying
506     #   test run executing this function. May be unset.
507     # Variables set:
508     # - TOPOLOGIES - Array of paths to topologies, with failed cleanups removed.
509     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
510     # Functions called:
511     # - die - Print to stderr and exit.
512     # Traps registered:
513     # - EXIT - Calls cancel_all for ${WORKING_TOPOLOGY}.
514
515     set -exuo pipefail
516
517     while [[ ${TOPOLOGIES[@]} ]]; do
518         for topo in "${TOPOLOGIES[@]}"; do
519             set +e
520             scrpt="${PYTHON_SCRIPTS_DIR}/topo_reservation.py"
521             opts=("-t" "${topo}" "-r" "${BUILD_TAG:-Unknown}")
522             opts+=("-u" "${BUILD_URL:-Unknown}")
523             python "${scrpt}" "${opts[@]}"
524             result="$?"
525             set -e
526             if [[ "${result}" == "0" ]]; then
527                 # Trap unreservation before cleanup check,
528                 # so multiple jobs showing failed cleanup improve chances
529                 # of humans to notice and fix.
530                 WORKING_TOPOLOGY="${topo}"
531                 echo "Reserved: ${WORKING_TOPOLOGY}"
532                 trap "untrap_and_unreserve_testbed" EXIT || {
533                     message="TRAP ATTEMPT AND UNRESERVE FAILED, FIX MANUALLY."
534                     untrap_and_unreserve_testbed "${message}" || {
535                         die "Teardown should have died, not failed."
536                     }
537                     die "Trap attempt failed, unreserve succeeded. Aborting."
538                 }
539                 # Cleanup check.
540                 set +e
541                 cleanup_topo
542                 result="$?"
543                 set -e
544                 if [[ "${result}" == "0" ]]; then
545                     break
546                 fi
547                 warn "Testbed cleanup failed: ${topo}"
548                 untrap_and_unreserve_testbed "Fail of unreserve after cleanup."
549                 # WORKING_TOPOLOGY is now empty again.
550                 # Build new topology array.
551                 #   TOPOLOGIES=("${TOPOLOGIES[@]/$topo}")
552                 # does not really work, see:
553                 # https://stackoverflow.com/questions/16860877/remove-an-element-from-a-bash-array
554                 new_topologies=()
555                 for item in "${TOPOLOGIES[@]}"; do
556                     if [[ "${item}" != "${topo}" ]]; then
557                         new_topologies+=("${item}")
558                     fi
559                 done
560                 TOPOLOGIES=("${new_topologies[@]}")
561                 break
562             fi
563         done
564
565         if [[ -n "${WORKING_TOPOLOGY-}" ]]; then
566             # Exit the infinite while loop if we made a reservation.
567             break
568         fi
569
570         # Wait ~3minutes before next try.
571         sleep_time="$[ ( $RANDOM % 20 ) + 180 ]s" || {
572             die "Sleep time calculation failed."
573         }
574         echo "Sleeping ${sleep_time}"
575         sleep "${sleep_time}" || die "Sleep failed."
576     done
577     if [[ ${TOPOLOGIES[@]} ]]; then
578         echo "Reservation and cleanup successful."
579     else
580         die "Run out of operational testbeds!"
581     fi
582 }
583
584
585 function run_pybot () {
586
587     # Run pybot with options based on input variables. Create output_info.xml
588     #
589     # Variables read:
590     # - CSIT_DIR - Path to existing root of local CSIT git repository.
591     # - ARCHIVE_DIR - Path to store robot result files in.
592     # - PYBOT_ARGS, EXPANDED_TAGS - See compose_pybot_arguments.sh
593     # - GENERATED_DIR - Tests are assumed to be generated under there.
594     # Variables set:
595     # - PYBOT_EXIT_STATUS - Exit status of most recent pybot invocation.
596     # Functions called:
597     # - die - Print to stderr and exit.
598
599     set -exuo pipefail
600
601     all_options=("--outputdir" "${ARCHIVE_DIR}" "${PYBOT_ARGS[@]}")
602     all_options+=("--noncritical" "EXPECTED_FAILING")
603     all_options+=("${EXPANDED_TAGS[@]}")
604
605     pushd "${CSIT_DIR}" || die "Change directory operation failed."
606     set +e
607     pybot "${all_options[@]}" "${GENERATED_DIR}/tests/"
608     PYBOT_EXIT_STATUS="$?"
609     set -e
610
611     # Generate INFO level output_info.xml for post-processing.
612     all_options=("--loglevel" "INFO")
613     all_options+=("--log" "none")
614     all_options+=("--report" "none")
615     all_options+=("--output" "${ARCHIVE_DIR}/output_info.xml")
616     all_options+=("${ARCHIVE_DIR}/output.xml")
617     rebot "${all_options[@]}" || true
618     popd || die "Change directory operation failed."
619 }
620
621
622 function select_tags () {
623
624     # Variables read:
625     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
626     # - TEST_CODE - String affecting test selection, usually jenkins job name.
627     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
628     #   Can be unset.
629     # - TOPOLOGIES_DIR - Path to existing directory with available tpologies.
630     # - BASH_FUNCTION_DIR - Directory with input files to process.
631     # Variables set:
632     # - TAGS - Array of processed tag boolean expressions.
633
634     set -exuo pipefail
635
636     # NIC SELECTION
637     start_pattern='^  TG:'
638     end_pattern='^ \? \?[A-Za-z0-9]\+:'
639     # Remove the TG section from topology file
640     sed_command="/${start_pattern}/,/${end_pattern}/d"
641     # All topologies DUT NICs
642     available=$(sed "${sed_command}" "${TOPOLOGIES_DIR}"/* \
643                 | grep -hoP "model: \K.*" | sort -u)
644     # Selected topology DUT NICs
645     reserved=$(sed "${sed_command}" "${WORKING_TOPOLOGY}" \
646                | grep -hoP "model: \K.*" | sort -u)
647     # All topologies DUT NICs - Selected topology DUT NICs
648     exclude_nics=($(comm -13 <(echo "${reserved}") <(echo "${available}"))) || {
649         die "Computation of excluded NICs failed."
650     }
651
652     # Select default NIC tag.
653     case "${TEST_CODE}" in
654         *"3n-dnv"* | *"2n-dnv"*)
655             default_nic="nic_intel-x553"
656             ;;
657         *"3n-tsh"*)
658             default_nic="nic_intel-x520-da2"
659             ;;
660         *)
661             default_nic="nic_intel-x710"
662             ;;
663     esac
664
665     # Tag file directory shorthand.
666     tfd="${BASH_FUNCTION_DIR}"
667     case "${TEST_CODE}" in
668         # Select specific performance tests based on jenkins job type variable.
669         *"ndrpdr-weekly"* )
670             readarray -t test_tag_array < "${tfd}/mlr-weekly.txt" || die
671             ;;
672         *"mrr-daily"* )
673             readarray -t test_tag_array < \
674                 "${tfd}/mrr-daily-${FLAVOR}.txt" || die
675             ;;
676         *"mrr-weekly"* )
677             readarray -t test_tag_array < "${tfd}/mrr-weekly.txt" || die
678             ;;
679         * )
680             if [[ -z "${TEST_TAG_STRING-}" ]]; then
681                 # If nothing is specified, we will run pre-selected tests by
682                 # following tags.
683                 test_tag_array=("mrrAND${default_nic}AND1cAND64bANDip4base"
684                                 "mrrAND${default_nic}AND1cAND78bANDip6base"
685                                 "mrrAND${default_nic}AND1cAND64bANDl2bdbase"
686                                 "mrrAND${default_nic}AND1cAND64bANDl2xcbase"
687                                 "!dot1q" "!drv_avf")
688             else
689                 # If trigger contains tags, split them into array.
690                 test_tag_array=(${TEST_TAG_STRING//:/ })
691             fi
692             ;;
693     esac
694
695     # Blacklisting certain tags per topology.
696     #
697     # Reasons for blacklisting:
698     # - ipsechw - Blacklisted on testbeds without crypto hardware accelerator.
699     # TODO: Add missing reasons here (if general) or where used (if specific).
700     case "${TEST_CODE}" in
701         *"2n-skx"*)
702             test_tag_array+=("!ipsechw")
703             ;;
704         *"3n-skx"*)
705             test_tag_array+=("!ipsechw")
706             # Not enough nic_intel-xxv710 to support double link tests.
707             test_tag_array+=("!3_node_double_link_topoANDnic_intel-xxv710")
708             ;;
709         *"2n-dnv"*)
710             test_tag_array+=("!ipsechw")
711             test_tag_array+=("!memif")
712             test_tag_array+=("!srv6_proxy")
713             test_tag_array+=("!vhost")
714             test_tag_array+=("!vts")
715             test_tag_array+=("!drv_avf")
716             ;;
717         *"3n-dnv"*)
718             test_tag_array+=("!memif")
719             test_tag_array+=("!srv6_proxy")
720             test_tag_array+=("!vhost")
721             test_tag_array+=("!vts")
722             test_tag_array+=("!drv_avf")
723             ;;
724         *"3n-tsh"*)
725             test_tag_array+=("!ipsechw")
726             test_tag_array+=("!memif")
727             test_tag_array+=("!srv6_proxy")
728             test_tag_array+=("!vhost")
729             test_tag_array+=("!vts")
730             ;;
731         *"3n-hsw"*)
732             # TODO: Introduce NOIOMMU version of AVF tests.
733             # TODO: Make (both) AVF tests work on Haswell,
734             # or document why (some of) it is not possible.
735             # https://github.com/FDio/vpp/blob/master/src/plugins/avf/README.md
736             test_tag_array+=("!drv_avf")
737             # All cards have access to QAT. But only one card (xl710)
738             # resides in same NUMA as QAT. Other cards must go over QPI
739             # which we do not want to even run.
740             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
741             ;;
742         *)
743             # Default to 3n-hsw due to compatibility.
744             test_tag_array+=("!drv_avf")
745             test_tag_array+=("!ipsechwNOTnic_intel-xl710")
746             ;;
747     esac
748
749     # We will add excluded NICs.
750     test_tag_array+=("${exclude_nics[@]/#/!NIC_}")
751
752     TAGS=()
753
754     # We will prefix with perftest to prevent running other tests
755     # (e.g. Functional).
756     prefix="perftestAND"
757     set +x
758     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
759         # Automatic prefixing for VPP jobs to limit the NIC used and
760         # traffic evaluation to MRR.
761         if [[ "${TEST_TAG_STRING-}" == *"nic_"* ]]; then
762             prefix="${prefix}mrrAND"
763         else
764             prefix="${prefix}mrrAND${default_nic}AND"
765         fi
766     fi
767     for tag in "${test_tag_array[@]}"; do
768         if [[ "${tag}" == "!"* ]]; then
769             # Exclude tags are not prefixed.
770             TAGS+=("${tag}")
771         elif [[ "${tag}" != "" && "${tag}" != "#"* ]]; then
772             # Empty and comment lines are skipped.
773             # Other lines are normal tags, they are to be prefixed.
774             TAGS+=("${prefix}${tag}")
775         fi
776     done
777     set -x
778 }
779
780
781 function select_vpp_device_tags () {
782
783     # Variables read:
784     # - TEST_CODE - String affecting test selection, usually jenkins job name.
785     # - TEST_TAG_STRING - String selecting tags, from gerrit comment.
786     #   Can be unset.
787     # Variables set:
788     # - TAGS - Array of processed tag boolean expressions.
789
790     set -exuo pipefail
791
792     case "${TEST_CODE}" in
793         # Select specific performance tests based on jenkins job type variable.
794         * )
795             if [[ -z "${TEST_TAG_STRING-}" ]]; then
796                 # If nothing is specified, we will run pre-selected tests by
797                 # following tags. Items of array will be concatenated by OR
798                 # in Robot Framework.
799                 test_tag_array=()
800             else
801                 # If trigger contains tags, split them into array.
802                 test_tag_array=(${TEST_TAG_STRING//:/ })
803             fi
804             ;;
805     esac
806
807     TAGS=()
808
809     # We will prefix with devicetest to prevent running other tests
810     # (e.g. Functional).
811     prefix="devicetestAND"
812     if [[ "${TEST_CODE}" == "vpp-"* ]]; then
813         # Automatic prefixing for VPP jobs to limit testing.
814         prefix="${prefix}"
815     fi
816     for tag in "${test_tag_array[@]}"; do
817         if [[ ${tag} == "!"* ]]; then
818             # Exclude tags are not prefixed.
819             TAGS+=("${tag}")
820         else
821             TAGS+=("${prefix}${tag}")
822         fi
823     done
824 }
825
826 function select_os () {
827
828     # Variables set:
829     # - VPP_VER_FILE - Name of File in CSIT dir containing vpp stable version.
830     # - IMAGE_VER_FILE - Name of File in CSIT dir containing the image name.
831     # - PKG_SUFFIX - Suffix of OS package file name, "rpm" or "deb."
832
833     set -exuo pipefail
834
835     os_id=$(grep '^ID=' /etc/os-release | cut -f2- -d= | sed -e 's/\"//g') || {
836         die "Get OS release failed."
837     }
838
839     case "${os_id}" in
840         "ubuntu"*)
841             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_UBUNTU"
842             VPP_VER_FILE="VPP_STABLE_VER_UBUNTU_BIONIC"
843             PKG_SUFFIX="deb"
844             ;;
845         "centos"*)
846             IMAGE_VER_FILE="VPP_DEVICE_IMAGE_CENTOS"
847             VPP_VER_FILE="VPP_STABLE_VER_CENTOS"
848             PKG_SUFFIX="rpm"
849             ;;
850         *)
851             die "Unable to identify distro or os from ${OS}"
852             ;;
853     esac
854 }
855
856
857 function select_topology () {
858
859     # Variables read:
860     # - NODENESS - Node multiplicity of testbed, either "2n" or "3n".
861     # - FLAVOR - Node flavor string, currently either "hsw" or "skx".
862     # - CSIT_DIR - Path to existing root of local CSIT git repository.
863     # - TOPOLOGIES_DIR - Path to existing directory with available topologies.
864     # Variables set:
865     # - TOPOLOGIES - Array of paths to suitable topology yaml files.
866     # - TOPOLOGIES_TAGS - Tag expression selecting tests for the topology.
867     # Functions called:
868     # - die - Print to stderr and exit.
869
870     set -exuo pipefail
871
872     case_text="${NODENESS}_${FLAVOR}"
873     case "${case_text}" in
874         # TODO: Move tags to "# Blacklisting certain tags per topology" section.
875         # TODO: Double link availability depends on NIC used.
876         "1n_vbox")
877             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
878             TOPOLOGIES_TAGS="2_node_single_link_topo"
879             ;;
880         "1n_skx" | "1n_tx2")
881             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*vpp_device*.template )
882             TOPOLOGIES_TAGS="2_node_single_link_topo"
883             ;;
884         "2n_skx")
885             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_skx*.yaml )
886             TOPOLOGIES_TAGS="2_node_*_link_topo"
887             ;;
888         "3n_skx")
889             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_skx*.yaml )
890             TOPOLOGIES_TAGS="3_node_*_link_topo"
891             ;;
892         "2n_dnv")
893             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*2n_dnv*.yaml )
894             TOPOLOGIES_TAGS="2_node_single_link_topo"
895             ;;
896         "3n_dnv")
897             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_dnv*.yaml )
898             TOPOLOGIES_TAGS="3_node_single_link_topo"
899             ;;
900         "3n_hsw")
901             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_hsw*.yaml )
902             TOPOLOGIES_TAGS="3_node_single_link_topo"
903             ;;
904         "3n_tsh")
905             TOPOLOGIES=( "${TOPOLOGIES_DIR}"/*3n_tsh*.yaml )
906             TOPOLOGIES_TAGS="3_node_*_link_topo"
907             ;;
908         *)
909             # No falling back to 3n_hsw default, that should have been done
910             # by the function which has set NODENESS and FLAVOR.
911             die "Unknown specification: ${case_text}"
912     esac
913
914     if [[ -z "${TOPOLOGIES-}" ]]; then
915         die "No applicable topology found!"
916     fi
917 }
918
919
920 function untrap_and_unreserve_testbed () {
921
922     # Use this as a trap function to ensure testbed does not remain reserved.
923     # Perhaps call directly before script exit, to free testbed for other jobs.
924     # This function is smart enough to avoid multiple unreservations (so safe).
925     # Topo cleanup is executed (call it best practice), ignoring failures.
926     #
927     # Hardcoded values:
928     # - default message to die with if testbed might remain reserved.
929     # Arguments:
930     # - ${1} - Message to die with if unreservation fails. Default hardcoded.
931     # Variables read (by inner function):
932     # - WORKING_TOPOLOGY - Path to topology yaml file of the reserved testbed.
933     # - PYTHON_SCRIPTS_DIR - Path to directory holding Python scripts.
934     # Variables written:
935     # - WORKING_TOPOLOGY - Set to empty string on successful unreservation.
936     # Trap unregistered:
937     # - EXIT - Failure to untrap is reported, but ignored otherwise.
938     # Functions called:
939     # - die - Print to stderr and exit.
940
941     set -xo pipefail
942     set +eu  # We do not want to exit early in a "teardown" function.
943     trap - EXIT || echo "Trap deactivation failed, continuing anyway."
944     wt="${WORKING_TOPOLOGY}"  # Just to avoid too long lines.
945     if [[ -z "${wt-}" ]]; then
946         set -eu
947         warn "Testbed looks unreserved already. Trap removal failed before?"
948     else
949         cleanup_topo || true
950         python "${PYTHON_SCRIPTS_DIR}/topo_reservation.py" -c -t "${wt}" || {
951             die "${1:-FAILED TO UNRESERVE, FIX MANUALLY.}" 2
952         }
953         WORKING_TOPOLOGY=""
954         set -eu
955     fi
956 }
957
958
959 function warn () {
960
961     # Print the message to standard error.
962     #
963     # Arguments:
964     # - ${@} - The text of the message.
965
966     set -exuo pipefail
967
968     echo "$@" >&2
969 }